LIBRARY ieee;
	USE ieee.std_logic_1164.all;
	USE ieee.numeric_std.all;
	
ENTITY multiplier IS
	PORT
	(
		a			: IN unsigned (7 DOWNTO 0);
		b			: IN unsigned (7 DOWNTO 0);
		clk		: IN std_logic;
		aclr		: IN std_logic;
		result	: OUT unsigned (15 DOWNTO 0)
	);
END multiplier;

ARCHITECTURE rtl OF multiplier IS
	SIGNAL a_reg, b_reg: unsigned (7 DOWNTO 0);
BEGIN
	PROCESS (clk, aclr)
	BEGIN
		IF (aclr = '1') THEN
			a_reg <= (OTHERS => '0');
			b_reg <= (OTHERS => '0');
			result <= (OTHERS => '0');
		ELSIF rising_edge(clk) THEN
			a_reg <= a;
			b_reg <= b;
			result <= a_reg * b_reg;
		END IF;
	END PROCESS;
END ARCHITECTURE rtl;